\ Test module for floating-point numbers.

depth negate pad !  0e depth pad +! fdrop
	pad @ constant float-cells

float-cells [if]  \ floats on data stack

	: fresult ( u flag.which -- r )
		cell-result float-cells
		cells over + swap do i @ 1 cells +loop ;
	float-cells constant /f

[else] \ separate float stack

1 constant /f

s" F:" max-results new-tester
0e fdup f/ fconstant float-defaced

#results: #fresults
create fresults[] max-results 2* floats allot
: fresults ( flag.which -- addr )
	[ max-results floats ] literal and fresults[] + ;
: fresult ( u flag.which -- r )
	fresults swap floats + f@ ;

[then] \ separate float stack

: both-fresults ( u -- r.received r.expected )
	dup >r received fresult  r> expected fresult ;

variable ftest=-xt
: ftest= ( r1 r2 -- flag )  ftest=-xt perform ;
: fresult= ( u -- flag u.step )  both-fresults ftest=  /f ;
: .fresult ( u flag.which -- u.step )  fresult f.  /f ;

float-cells [if]  : float-type cell-type ;
[else]  \ separate float stack

variable fdepth0
: float-depth ( -- n )  fdepth fdepth0 @ - ;
:noname ( -- )  fdepth fdepth0 !
	['] fresult= ['] .fresult max-results default-types ;
	begin-test-xt !
:noname ( ... flag.which -- )
	float-depth swap  2dup #fresults !
	over 0> if fresults swap
		1- floats over + do  i f!  -1 floats +loop
	else drop negate 0 ?do float-defaced loop then ;
	save-stack-xt !
test-types constant float-types
: float-type ( xt.test xt.print -- )
	float-types float-depth test-type! ;

[then]


( floating-point comparisons )

\ same internal representation
: fdatum= ( r1 r2 -- flag )  0e f~ ;

\ |r1 - r2| < epsilon
fvariable ft-abs-error 0e ft-abs-error f!
: fabs= ( r1 r2 -- flag )  ft-abs-error f@ f~ ;

\ |measured - reference| < epsilon * |reference|
fvariable ft-rel-error 1e-12 ft-rel-error f!
: frel= ( r.measured r.reference -- flag )
	fswap fover f- fswap f/ fabs ft-rel-error f@ f< ;

\ |r1 - r2| < epsilon * (|r1| + |r2|)/2
fvariable ft-arel-error 1e-12 ft-arel-error f!
: farel= ( r1 r2 -- flag )  ft-arel-error f@ fnegate 2e f/ f~ ;

: frel0= ( r.measured r.reference -- flag )  \ Krishna Myneni
	fdup f0= if fabs= else frel= then ;


( set default mode )

: set-ft-mode-exact ( -- )  ['] fdatum= ftest=-xt ! ;
: set-ft-mode-abs   ( -- )  ['] fabs=   ftest=-xt ! ;
: set-ft-mode-rel   ( -- )  ['] frel=   ftest=-xt ! ;
: set-ft-mode-arel  ( -- )  ['] farel=  ftest=-xt ! ;
: set-ft-mode-rel0  ( -- )  ['] frel0=  ftest=-xt ! ;

set-ft-mode-exact


( set mode per-item )

\ If you want your tests to work on a combined data/float stack,
\ you *must* mark each float.

: float-type: ( xt-test xt.print "name" -- )
	2>r : ( -- )
		2r> postpone 2literal postpone float-type
	postpone ; ;
: ftest: ( xt "name" -- )  \ name ( u -- u' flag )
	>r :noname  postpone both-fresults r> compile,
	postpone /f postpone ;
	['] .fresult float-type: ;

' fresult= ' .fresult float-type: F:
' fdatum= ftest: =F:
' fabs=   ftest: |F|
' frel=   ftest: ~F:
' farel= ftest: |~F|
' frel0=  ftest: ~F|0
